//
//  SOMAFacebookNativeCSMPlugin.m
//  iSoma
//
//  Created by Aman Shaikh on 11.05.16.
//  Copyright © 2016 Smaato Inc. All rights reserved.
//

#import "SOMAFacebookNativeCSMPlugin.h"
#import "iSoma.h"
#import "SOMANativeAdDto.h"

@implementation SOMAFacebookNativeCSMPlugin


- (void)load{
	self.nativeAd = [[FBNativeAd alloc] initWithPlacementID:self.network.adunitid];
	self.nativeAd.delegate = self;
	[self.nativeAd loadAd];
}

- (void)registerViewForUserInteraction:(UIView*)view withRootViewController:(UIViewController*)rootViewController{
	if (self.adchoiseView.superview) {
		[self.adchoiseView removeFromSuperview];
	}
	self.adchoiseView = [[FBAdChoicesView alloc] initWithNativeAd:self.nativeAd];
	[view addSubview:self.adchoiseView];
	[self.adchoiseView updateFrameFromSuperview];
	[self.nativeAd registerViewForInteraction:view withViewController:rootViewController];
}

- (void)nativeAdDidLoad:(FBNativeAd *)fbad{
	
	self.adCoverMediaView = [[FBMediaView alloc] initWithNativeAd:fbad];
	SOMANativeAdDTO* dto = [SOMANativeAdDTO new];
	dto.iconImageURL = fbad.icon.url;
	dto.callToAction = fbad.callToAction;
	dto.title = fbad.title;
	dto.text = fbad.body;
	dto.mediaView = self.adCoverMediaView;
	
	dto.starrating = 5*fbad.starRating.value/fbad.starRating.scale;
	
	[self.csmDelegate nativeCSMPluginDidLoad:self withDTO:dto];
}

- (void)nativeAd:(FBNativeAd *)nativeAd didFailWithError:(NSError *)error{
	[self.csmDelegate nativeCSMPluginDidFail:self];
}

- (void)nativeAdWillLogImpression:(FBNativeAd *)nativeAd{
	[self.csmDelegate nativeCSMPluginLogImpresion:self];
}

- (void)nativeAdDidClick:(FBNativeAd *)nativeAd{
	[self.csmDelegate nativeCSMPluginLogClick:self];
}
@end
